/*
 * UDP send/receive tool for packet loss detection.
 * Copyright 2007 by Toru Takahashi.
 */
package receiver;

import java.awt.event.ActionListener;
import java.awt.event.WindowListener;
import java.util.Vector;

/**
 * UdpReceivervOɂāAModel-View-Presenterp^[ۂ
 * View̃C^tF[XB
 * $Id$
 */
public interface UdpReceiveView {
    /**
     * M|[gꗗViewɃZbgB
     * @param list M|[gԍ()ێ郊Xg
     */
    void setPortList(Vector<Integer> list);
    /**
     * Mf[^TCYꗗViewɃZbgB
     * @param list MMf[^TCY()ێ郊Xg
     */
    void setSizeList(Vector<Integer> list);
    /**
     * Mobt@TCYꗗViewɃZbgB
     * @param list Mobt@TCY()ێ郊Xg
     */
    void setBufferList(Vector<Integer> list);
    /**
     * M񐔂ɕ\lZbg
     * @param aCount MpPbg
     */
    void setCount(int aCount);
    /**
     * MIDɕ\錻ݒl/vlZbg
     * @param aCurrent ݒl
     * @param aTotalCount vl
     */
    void setCurrent(int aCurrent, int aTotalCount);
    /**
     * pPbgIDZbg
     * @param anId pPbgID
     */
    void putSkippedPacketId(int anId);
    /**
     * pPbg\GA
     */
    void clearSkippedPacketId();
    /**
     * ViewőIꂽM|[g擾
     * @return ViewőIꂽM|[gԍ
     */
    int getPort();
    /**
     * ViewőIꂽMf[^TCY擾
     * @return ViewőIꂽMf[^TCY[byte]
     */
    int getDataSize();
    /**
     * ViewőIꂽMobt@TCY擾
     * @return ViewőIꂽMobt@TCY[byte]
     */
    int getBufferSize();
    /**
     * ViewŎM삪sꂽCxgʒm郊Xi[o^
     * @param aListener M삪ViewŔƂɒʒm󂯂郊Xi
     */
    void addReceiveListener(ActionListener aListener);
    /**
     * ViewŃEBhE֘ACxgʒm郊Xi[o^
     * @param aListener EBhE삪ViewŔƂɒʒm󂯂郊Xi
     */
    void addViewListener(WindowListener aListener);
    /**
     * View݉
     */
    void showView();
    /**
     * ViewɃG[\(_CAO\)
     * @param e G[\O
     */
     void showError(Exception e);
}
