/*
 * UDP send/receive tool for packet loss detection.
 * Copyright 2007 by Toru Takahashi.
 */
package receiver;

import model.UdpModel;
import java.util.Vector;
import java.util.Set;

/**
 * UdpReceivervOɂāAModel-View-Presenterp^[ۂ
 * Model̎B
 *
 * $Id$
 */
public class UdpReceiveModel extends UdpModel {
    /**
     * ftHgERXgN^B
     * Preferences APIŉiꂽf[^擾tB[hɃZbgB
     */
    public UdpSendModel() {
     public UdpReceiveModel() {
        super(UdpReceiveModel.class);
        
        portSet = readIntegerSetFromPreferences(KEY_PORT, 1234);
        dataSizeSet = readIntegerSetFromPreferences(KEY_DATA_SIZE, 100);
        bufferSizeSet = readIntegerSetFromPreferences(KEY_BUFFER_SIZE, 8192);
    }

    /**
     * Preferences APIɃf[^ۑB
     */
    public void save() {
        putToPreferences(KEY_PORT, getStringForPreferences(portSet));
        putToPreferences(KEY_DATA_SIZE, getStringForPreferences(dataSizeSet));
        putToPreferences(KEY_BUFFER_SIZE, getStringForPreferences(bufferSizeSet));
    }

    public void addPort(final int aPort) {
        portSet.add(aPort);
    }

    public void addDataSize(final int aSize) {
        dataSizeSet.add(aSize);
    }

    public void addBufferSize(final int aSize) {
        bufferSizeSet.add(aSize);
    }

    public Vector<Integer> getPortList() {
        return new Vector<Integer>(portSet);
    }

    public Vector<Integer> getDataSizeList() {
        return new Vector<Integer>(dataSizeSet);
    }

    public Vector<Integer> getBufferSizeList() {
        return new Vector<Integer>(bufferSizeSet);
    }

    private Set<Integer> portSet;
    private Set<Integer> dataSizeSet;
    private Set<Integer> bufferSizeSet;
    private static final String KEY_PORT = "port";
    private static final String KEY_DATA_SIZE = "dataSize";
    private static final String KEY_BUFFER_SIZE = "bufferSize";
}
